import { Injectable } from '@angular/core';

import { DbHandle } from './db-handle';

import { Hero } from './hero';
import { HEROES } from './mock-heroes';
import { MessageService } from './message.service';

@Injectable({
  providedIn: 'root'
})
export class HeroService {
  constructor(private messageService: MessageService) { }

  async getHeroes(): Promise<Hero[]> {
    this.messageService.add('HeroService: fetched heroes');
    const dbHandle = new DbHandle()
    try {
      await dbHandle.connect()
      const result = await dbHandle.query('SELECT id, name FROM hero')
      return result.map((row: Record<string, unknown>) => {
        return {id: row.id ?? -1, name: row.name ?? 'unknown' }
      })
    } finally {
      dbHandle.close()
    }
  }

  async getHero(id: number): Promise<Hero> {
    this.messageService.add(`HeroService: fetch hero id=${id}`);
    const dbHandle = new DbHandle()
    try {
      await dbHandle.connect()
      const result = await dbHandle.query(`SELECT id, name FROM hero WHERE id = ${id}`)
      return { id: result[0].id ?? -1, name: result[0].name ?? 'unknown' }
    } finally {
      dbHandle.close()
    }
  }

  updateHero(hero: Hero): Promise<any> {
    this.messageService.add(`HeroService: save change: id=${hero.id}, name=${hero.name}`);
    return Promise.resolve(true);
  }
}
